Subject: Re: bug#22970: guix edit mutt -- not working

From: Jean Louis <[email-masked]>
Date: Thu, 10 Mar 2016 20:34:42 +0100

Hello Andreas,

I have now 2 files in gnu/guix/packages/*.scm, for mutt and postgresql:
and now I get each time on running guix, following:

guix package: warning: failed to load '(databases)':
ERROR: no code for module (databases)
guix package: warning: failed to load '(mutt)':
ERROR: no code for module (mutt)

because 2 files are: databases.scm and mutt.scm

I have already installed mutt, with changes, and it works. On the end of
file there is word "mutt". Similar for PostgreSQL, only it did not yet
compile.

Now I get a feeling, if I have 20 files to change or adapt to my system,
I will get 20 warnings by each run of guix package manager.

Somehow it does not feel right.

It would be more logical to have GUIX_PACKAGE_PATH plus one separate
file where some modified or user related packages are listed, instead of
having the package name on the end of *.scm file.

On Thu, Mar 10, 2016 at 12:44:33AM +0100, Andreas Enge wrote:
> On Thu, Mar 10, 2016 at 12:22:20AM +0100, Jean Louis wrote:
> > And I could not save the file in my home directory, and do:
> > guix package -i mutt -f mail.scm
> 
> As mentioned on IRC, modify the file mail.scm by adding a line
>    mutt
> at the end. Then
>    guix package -f mail.scm
> does "install the package that the code within FILE evaluates to" as
> explained by "guix package --help". mail.scm itself does not evaluate
> to anything, it just contains a number of variable definitions. By adding
> the line, it "returns" the value of the variable mutt, which is your
> package definition.
> 
> Better yet, use GUIX_PACKAGE_PATH, for instance as follows:
>    export GUIX_PACKAGE_PATH=$HOME/guix
> Then create the same file layout in that directory as in the source code:
>    mkdir -p $HOME/guix/gnu/packages
> Copy mail.scm there, modify mutt, then
>    guix package -i mutt
> will first look for your modified package.
> 
> As this is not a bug, it would have been better to post to [email-masked];
> let us continue the discussion there (if you are not yet subscribed, please
> do so), and I am closing this bug.
> 
> Andreas
> 
>